// Use this header to dynamically load and bind coppeliaSim.dll and its functions (call loadSimLibrary and unloadSimLibrary)

#if !defined(SIMLIB_INCLUDED_)
#define SIMLIB_INCLUDED_

#include "simConst.h"
#include "simTypes.h"
#ifdef SIM_INTERFACE_SINGLE
#define SIMDOUBLE float
#else
#define SIMDOUBLE double
#endif

#ifdef QT_FRAMEWORK
    #include <QLibrary>
    #include <QDebug>
    #define LIBRARY QLibrary*
    #define __cdecl
    #define FARPROC void*
#else
    #ifdef _WIN32
        #include <Windows.h>
        #define LIBRARY HINSTANCE
    #elif defined (__linux) || defined (__APPLE__)
        #define __cdecl
        #define FARPROC void*
        #define LIBRARY void*
    #endif
    #include <stdio.h>
#endif // QT_FRAMEWORK

int getSimProcAddresses(LIBRARY lib);
LIBRARY loadSimLibrary(const char* pathAndFilename);
void unloadSimLibrary(LIBRARY lib);
FARPROC _getProcAddress(LIBRARY lib,const char* funcName);
int simAddLog(const char* pluginName,int verbosityLevel,const char* logMsg);

typedef int (__cdecl *ptrSimAddLog)(const char* pluginName,int verbosityLevel,const char* logMsg);
typedef int (__cdecl *ptrSimRunSimulator)(const char* applicationName,int options,void(*initCallBack)(),void(*loopCallBack)(),void(*deinitCallBack)());
typedef int (__cdecl *ptrSimRunSimulatorEx)(const char* applicationName,int options,void(*initCallBack)(),void(*loopCallBack)(),void(*deinitCallBack)(),int stopDelay,const char* sceneOrModelToLoad);
typedef char* (__cdecl *ptrSimGetSimulatorMessage)(int* messageID,int* auxiliaryData,int* returnedDataSize);
typedef void* (__cdecl *ptrSimGetMainWindow)(int type);
typedef char* (__cdecl *ptrSimGetLastError)();
typedef int (__cdecl *ptrSimLoadModule)(const char* filenameAndPath,const char* pluginName);
typedef int (__cdecl *ptrSimUnloadModule)(int pluginhandle);
typedef int (__cdecl *ptrSimSetBoolParam)(int Param,bool boolState);
typedef int (__cdecl *ptrSimGetBoolParam)(int Param);
typedef int (__cdecl *ptrSimSetInt32Param)(int Param,int intState);
typedef int (__cdecl *ptrSimGetInt32Param)(int Param,int* intState);
typedef int (__cdecl *ptrSimGetUInt64Param)(int Param,unsigned long long int* intState);
typedef int (__cdecl *ptrSimSetStringParam)(int Param,const char* stringState);
typedef char* (__cdecl *ptrSimGetStringParam)(int Param);
typedef int (__cdecl *ptrSimSetNamedStringParam)(const char* paramName,const char* stringParam,int paramLength);
typedef char* (__cdecl *ptrSimGetNamedStringParam)(const char* paramName,int* paramLength);
typedef int (__cdecl *ptrSimGetObject)(const char* objectPath,int index,int proxy,int options);
typedef long long int (__cdecl *ptrSimGetObjectUid)(int objectHandle);
typedef int (__cdecl *ptrSimGetObjectFromUid)(long long int uid,int options);
typedef int (__cdecl *ptrSimGetScriptHandleEx)(int scriptType,int objHandle,const char* scriptName);
typedef int (__cdecl *ptrSimRemoveObjects)(const int* objectHandles,int count);
typedef int (__cdecl *ptrSimRemoveModel)(int objectHandle);
typedef char* (__cdecl *ptrSimGetObjectAlias)(int objectHandle,int options);
typedef int (__cdecl *ptrSimSetObjectAlias)(int objectHandle,const char* objectAlias,int options);
typedef int (__cdecl *ptrSimGetObjectParent)(int objectHandle);
typedef int (__cdecl *ptrSimGetObjectChild)(int objectHandle,int index);
typedef int (__cdecl *ptrSimSetObjectParent)(int objectHandle,int parentObjectHandle,bool keepInPlace);
typedef int (__cdecl *ptrSimGetObjectType)(int objectHandle);
typedef int (__cdecl *ptrSimGetJointType)(int objectHandle);
typedef int (__cdecl *ptrSimReservedCommand)(int v,int w);
typedef int (__cdecl *ptrSimGetSimulationState)();
typedef int (__cdecl *ptrSimLoadScene)(const char* filename);
typedef int (__cdecl *ptrSimCloseScene)();
typedef int (__cdecl *ptrSimSaveScene)(const char* filename);
typedef int (__cdecl *ptrSimLoadModel)(const char* filename);
typedef int (__cdecl *ptrSimSaveModel)(int baseOfModelHandle,const char* filename);
typedef int (__cdecl *ptrSimDoesFileExist)(const char* filename);
typedef int* (__cdecl *ptrSimGetObjectSel)(int* cnt);
typedef int (__cdecl *ptrSimSetObjectSel)(const int* handles,int cnt);
typedef int (__cdecl *ptrSimAssociateScriptWithObject)(int scriptHandle,int associatedObjectHandle);
typedef int (__cdecl *ptrSimHandleMainScript)();
typedef int (__cdecl *ptrSimResetScript)(int scriptHandle);
typedef int (__cdecl *ptrSimAddScript)(int scriptProperty);
typedef int (__cdecl *ptrSimRemoveScript)(int scriptHandle);
typedef int (__cdecl *ptrSimRefreshDialogs)(int refreshDegree);
typedef int (__cdecl *ptrSimResetProximitySensor)(int sensorHandle);
typedef void* (__cdecl *ptrSimCreateBuffer)(int size);
typedef int (__cdecl *ptrSimReleaseBuffer)(const void* buffer);
typedef int (__cdecl *ptrSimCheckCollision)(int entity1Handle,int entity2Handle);
typedef int (__cdecl *ptrSimGetRealTimeSimulation)();
typedef int (__cdecl *ptrSimIsRealTimeSimulationStepNeeded)();
typedef int (__cdecl *ptrSimGetSimulationPassesPerRenderingPass)();
typedef int (__cdecl *ptrSimAdvanceSimulationByOneStep)();
typedef int (__cdecl *ptrSimStartSimulation)();
typedef int (__cdecl *ptrSimStopSimulation)();
typedef int (__cdecl *ptrSimPauseSimulation)();
typedef char* (__cdecl *ptrSimGetModuleName)(int index,unsigned char* moduleVersion);
typedef int (__cdecl *ptrSimAdjustView)(int viewHandleOrIndex,int associatedViewableObjectHandle,int options,const char* viewLabel);
typedef int (__cdecl *ptrSimSetLastError)(const char* funcName,const char* errorMessage);
typedef int (__cdecl *ptrSimResetGraph)(int graphHandle);
typedef int (__cdecl *ptrSimDestroyGraphCurve)(int graphHandle,int curveId);
typedef int (__cdecl *ptrSimDuplicateGraphCurveToStatic)(int graphHandle,int curveId,const char* curveName);
typedef int (__cdecl *ptrSimSetNavigationMode)(int navigationMode);
typedef int (__cdecl *ptrSimGetNavigationMode)();
typedef int (__cdecl *ptrSimSetPage)(int index);
typedef int (__cdecl *ptrSimGetPage)();
typedef int (__cdecl *ptrSimRegisterScriptCallbackFunction)(const char* funcNameAtPluginName,const char* callTips,void(*callBack)(struct SScriptCallBack* cb));
typedef int (__cdecl *ptrSimRegisterScriptVariable)(const char* varNameAtPluginName,const char* varValue,int stackHandle);
typedef int (__cdecl *ptrSimRegisterScriptFuncHook)(int scriptHandle,const char* funcToHook,const char* userFunction,bool executeBefore,int options);
typedef int (__cdecl *ptrSimCopyPasteObjects)(int* objectHandles,int objectCount,int options);
typedef int (__cdecl *ptrSimRemoveDrawingObject)(int objectHandle);
typedef int (__cdecl *ptrSimAnnounceSceneContentChange)();
typedef int (__cdecl *ptrSimSetInt32Signal)(const char* signalName,int signalValue);
typedef int (__cdecl *ptrSimGetInt32Signal)(const char* signalName,int* signalValue);
typedef int (__cdecl *ptrSimClearInt32Signal)(const char* signalName);
typedef int (__cdecl *ptrSimClearFloatSignal)(const char* signalName);
typedef int (__cdecl *ptrSimSetStringSignal)(const char* signalName,const char* signalValue,int stringLength);
typedef char* (__cdecl *ptrSimGetStringSignal)(const char* signalName,int* stringLength);
typedef int (__cdecl *ptrSimClearStringSignal)(const char* signalName);
typedef char* (__cdecl *ptrSimGetSignalName)(int signalIndex,int signalType);
typedef int (__cdecl *ptrSimSetObjectProperty)(int objectHandle,int prop);
typedef int (__cdecl *ptrSimGetObjectProperty)(int objectHandle);
typedef int (__cdecl *ptrSimSetObjectSpecialProperty)(int objectHandle,int prop);
typedef int (__cdecl *ptrSimGetObjectSpecialProperty)(int objectHandle);
typedef int (__cdecl *ptrSimSetExplicitHandling)(int objectHandle,int explicitFlags);
typedef int (__cdecl *ptrSimGetExplicitHandling)(int objectHandle);
typedef int (__cdecl *ptrSimGetLinkDummy)(int dummyHandle);
typedef int (__cdecl *ptrSimSetLinkDummy)(int dummyHandle,int linkedDummyHandle);
typedef int (__cdecl *ptrSimSetModelProperty)(int objectHandle,int modelProperty);
typedef int (__cdecl *ptrSimGetModelProperty)(int objectHandle);
typedef int (__cdecl *ptrSimResetDynamicObject)(int objectHandle);
typedef int (__cdecl *ptrSimSetJointMode)(int jointHandle,int jointMode,int options);
typedef int (__cdecl *ptrSimGetJointMode)(int jointHandle,int* options);
typedef int (__cdecl *ptrSimSerialOpen)(const char* portString,int baudRate,void* reserved1,void* reserved2);
typedef int (__cdecl *ptrSimSerialClose)(int portHandle);
typedef int (__cdecl *ptrSimSerialSend)(int portHandle,const char* data,int dataLength);
typedef int (__cdecl *ptrSimSerialRead)(int portHandle,char* buffer,int dataLengthToRead);
typedef int (__cdecl *ptrSimSerialCheck)(int portHandle);
typedef int (__cdecl *ptrSimAuxiliaryConsoleClose)(int consoleHandle);
typedef int (__cdecl *ptrSimAuxiliaryConsoleShow)(int consoleHandle,bool showState);
typedef int (__cdecl *ptrSimAuxiliaryConsolePrint)(int consoleHandle,const char* text);
typedef int (__cdecl *ptrSimGetObjectInt32Param)(int objectHandle,int parameterID,int* parameter);
typedef int (__cdecl *ptrSimSetObjectInt32Param)(int objectHandle,int parameterID,int parameter);
typedef char* (__cdecl *ptrSimGetObjectStringParam)(int objectHandle,int parameterID,int* parameterLength);
typedef int (__cdecl *ptrSimSetObjectStringParam)(int objectHandle,int parameterID,const char* parameter,int parameterLength);
typedef int (__cdecl *ptrSimSetSimulationPassesPerRenderingPass)(int p);
typedef int (__cdecl *ptrSimPersistentDataWrite)(const char* dataName,const char* dataValue,int dataLength,int options);
typedef char* (__cdecl *ptrSimPersistentDataRead)(const char* dataName,int* dataLength);
typedef int (__cdecl *ptrSimIsHandle)(int generalObjectHandle,int generalObjectType);
typedef int (__cdecl *ptrSimResetVisionSensor)(int visionSensorHandle);
typedef int (__cdecl *ptrSimSetVisionSensorImg)(int sensorHandle,const unsigned char* img,int options,const int* pos,const int* size);
typedef int (__cdecl *ptrSimRuckigRemove)(int objHandle);
typedef int (__cdecl *ptrSimGroupShapes)(const int* shapeHandles,int shapeCount);
typedef int* (__cdecl *ptrSimUngroupShape)(int shapeHandle,int* shapeCount);
typedef void (__cdecl *ptrSimQuitSimulator)(bool ignoredArgument);
typedef int (__cdecl *ptrSimSetShapeMaterial)(int shapeHandle,int materialIdOrShapeHandle);
typedef int (__cdecl *ptrSimGetTextureId)(const char* textureName,int* resolution);
typedef unsigned char* (__cdecl *ptrSimReadTexture)(int textureId,int options,int posX,int posY,int sizeX,int sizeY);
typedef int (__cdecl *ptrSimWriteCustomDataBlock)(int objectHandle,const char* tagName,const char* data,int dataSize);
typedef char* (__cdecl *ptrSimReadCustomDataBlock)(int objectHandle,const char* tagName,int* dataSize);
typedef char* (__cdecl *ptrSimReadCustomDataBlockTags)(int objectHandle,int* tagCount);
typedef int (__cdecl *ptrSimGetObjects)(int index,int objectType);
typedef int* (__cdecl *ptrSimGetObjectsInTree)(int treeBaseHandle,int objectType,int options,int* objectCount);
typedef int (__cdecl *ptrSimGetShapeTextureId)(int shapeHandle);
typedef int (__cdecl *ptrSimCreateCollectionEx)(int options);
typedef int (__cdecl *ptrSimAddItemToCollection)(int collectionHandle,int what,int objectHandle,int options);
typedef int (__cdecl *ptrSimDestroyCollection)(int collectionHandle);
typedef int* (__cdecl *ptrSimGetCollectionObjects)(int collectionHandle,int* objectCount);
typedef int (__cdecl *ptrSimGetScriptInt32Param)(int scriptHandle,int parameterID,int* parameter);
typedef int (__cdecl *ptrSimSetScriptInt32Param)(int scriptHandle,int parameterID,int parameter);
typedef char* (__cdecl *ptrSimGetScriptStringParam)(int scriptHandle,int parameterID,int* parameterLength);
typedef int (__cdecl *ptrSimSetScriptStringParam)(int scriptHandle,int parameterID,const char* parameter,int parameterLength);
typedef int (__cdecl *ptrSimAlignShapeBB)(int shapeHandle,const double* pose);
typedef int (__cdecl *ptrSimRelocateShapeFrame)(int shapeHandle,const double* pose);
typedef int (__cdecl *ptrSimSaveImage)(const unsigned char* image,const int* resolution,int options,const char* filename,int quality,void* reserved);
typedef unsigned char* (__cdecl *ptrSimLoadImage)(int* resolution,int options,const char* filename,void* reserved);
typedef unsigned char* (__cdecl *ptrSimGetScaledImage)(const unsigned char* imageIn,const int* resolutionIn,int* resolutionOut,int options,void* reserved);
typedef int (__cdecl *ptrSimCallScriptFunctionEx)(int scriptHandleOrType,const char* functionNameAtScriptName,int stackId);
typedef char* (__cdecl *ptrSimGetExtensionString)(int objectHandle,int index,const char* key);
typedef int (__cdecl *ptrSimCreateStack)();
typedef int (__cdecl *ptrSimReleaseStack)(int stackHandle);
typedef int (__cdecl *ptrSimCopyStack)(int stackHandle);
typedef int (__cdecl *ptrSimPushNullOntoStack)(int stackHandle);
typedef int (__cdecl *ptrSimPushBoolOntoStack)(int stackHandle,bool value);
typedef int (__cdecl *ptrSimPushInt32OntoStack)(int stackHandle,int value);
typedef int (__cdecl *ptrSimPushInt64OntoStack)(int stackHandle,long long int value);
typedef int (__cdecl *ptrSimPushStringOntoStack)(int stackHandle,const char* value,int stringSize);
typedef int (__cdecl *ptrSimPushUInt8TableOntoStack)(int stackHandle,const unsigned char* values,int valueCnt);
typedef int (__cdecl *ptrSimPushInt32TableOntoStack)(int stackHandle,const int* values,int valueCnt);
typedef int (__cdecl *ptrSimPushInt64TableOntoStack)(int stackHandle,const long long int* values,int valueCnt);
typedef int (__cdecl *ptrSimPushTableOntoStack)(int stackHandle);
typedef int (__cdecl *ptrSimInsertDataIntoStackTable)(int stackHandle);
typedef int (__cdecl *ptrSimGetStackSize)(int stackHandle);
typedef int (__cdecl *ptrSimPopStackItem)(int stackHandle,int count);
typedef int (__cdecl *ptrSimMoveStackItemToTop)(int stackHandle,int cIndex);
typedef int (__cdecl *ptrSimIsStackValueNull)(int stackHandle);
typedef int (__cdecl *ptrSimGetStackBoolValue)(int stackHandle,bool* boolValue);
typedef int (__cdecl *ptrSimGetStackInt32Value)(int stackHandle,int* numberValue);
typedef int (__cdecl *ptrSimGetStackInt64Value)(int stackHandle,long long int* numberValue);
typedef char* (__cdecl *ptrSimGetStackStringValue)(int stackHandle,int* stringSize);
typedef int (__cdecl *ptrSimGetStackTableInfo)(int stackHandle,int infoType);
typedef int (__cdecl *ptrSimGetStackUInt8Table)(int stackHandle,unsigned char* array,int count);
typedef int (__cdecl *ptrSimGetStackInt32Table)(int stackHandle,int* array,int count);
typedef int (__cdecl *ptrSimGetStackInt64Table)(int stackHandle,long long int* array,int count);
typedef int (__cdecl *ptrSimUnfoldStackTable)(int stackHandle);
typedef int (__cdecl *ptrSimDebugStack)(int stackHandle,int cIndex);
typedef int (__cdecl *ptrSimGetEngineInt32Param)(int paramId,int objectHandle,const void* object,bool* ok);
typedef bool (__cdecl *ptrSimGetEngineBoolParam)(int paramId,int objectHandle,const void* object,bool* ok);
typedef int (__cdecl *ptrSimSetEngineInt32Param)(int paramId,int objectHandle,const void* object,int val);
typedef int (__cdecl *ptrSimSetEngineBoolParam)(int paramId,int objectHandle,const void* object,bool val);
typedef int (__cdecl *ptrSimInsertObjectIntoOctree)(int octreeHandle,int objectHandle,int options,const unsigned char* color,unsigned int tag,void* reserved);
typedef int (__cdecl *ptrSimSubtractObjectFromOctree)(int octreeHandle,int objectHandle,int options,void* reserved);
typedef char* (__cdecl *ptrSimOpenTextEditor)(const char* initText,const char* xml,int* various);
typedef char* (__cdecl *ptrSimPackTable)(int stackHandle,int* bufferSize);
typedef int (__cdecl *ptrSimUnpackTable)(int stackHandle,const char* buffer,int bufferSize);
typedef int (__cdecl *ptrSimSetReferencedHandles)(int objectHandle,int count,const int* referencedHandles,const int* reserved1,const int* reserved2);
typedef int (__cdecl *ptrSimGetReferencedHandles)(int objectHandle,int** referencedHandles,int** reserved1,int** reserved2);
typedef int (__cdecl *ptrSimExecuteScriptString)(int scriptHandleOrType,const char* stringAtScriptName,int stackHandle);
typedef char* (__cdecl *ptrSimGetApiFunc)(int scriptHandleOrType,const char* apiWord);
typedef char* (__cdecl *ptrSimGetApiInfo)(int scriptHandleOrType,const char* apiWord);
typedef int (__cdecl *ptrSimSetModuleInfo)(const char* moduleName,int infoType,const char* stringInfo,int intInfo);
typedef int (__cdecl *ptrSimGetModuleInfo)(const char* moduleName,int infoType,char** stringInfo,int* intInfo);
typedef int (__cdecl *ptrSimIsDeprecated)(const char* funcOrConst);
typedef char* (__cdecl *ptrSimGetPersistentDataTags)(int* tagCount);
typedef int (__cdecl *ptrSimEventNotification)(const char* event);
typedef int (__cdecl *ptrSimIsDynamicallyEnabled)(int objectHandle);
typedef int (__cdecl *ptrSimInitScript)(int scriptHandle);
typedef int (__cdecl *ptrSimModuleEntry)(int handle,const char* label,int state);
typedef int (__cdecl *ptrSimCheckExecAuthorization)(const char* what,const char* args);
/* ------------------------------------------------------- */
typedef int (__cdecl *ptrSimPushFloatOntoStack)(int stackHandle,float value);
typedef int (__cdecl *ptrSimPushFloatTableOntoStack)(int stackHandle,const float* values,int valueCnt);
typedef int (__cdecl *ptrSimGetStackFloatValue)(int stackHandle,float* numberValue);
typedef int (__cdecl *ptrSimGetStackFloatTable)(int stackHandle,float* array,int count);
typedef float* (__cdecl *ptrSimGetVisionSensorDepth)(int sensorHandle,int options,const int* pos,const int* size,int* resolution);
typedef int (__cdecl *ptr_simSetVisionSensorDepth)(int sensorHandle,int options,const float* depth);
typedef float* (__cdecl *ptrSimCheckVisionSensorEx)(int visionSensorHandle,int entityHandle,bool returnImage);
/* ------------------------------------------------------- */
typedef int (__cdecl *ptrSimRuckigPos)(int dofs,double baseCycleTime,int flags,const double* currentPos,const double* currentVel,const double* currentAccel,const double* maxVel,const double* maxAccel,const double* maxJerk,const bool* selection,const double* targetPos,const double* targetVel,double* reserved1,int* reserved2);
typedef int (__cdecl *ptrSimRuckigVel)(int dofs,double baseCycleTime,int flags,const double* currentPos,const double* currentVel,const double* currentAccel,const double* maxAccel,const double* maxJerk,const bool* selection,const double* targetVel,double* reserved1,int* reserved2);
typedef int (__cdecl *ptrSimRuckigStep)(int objHandle,double cycleTime,double* newPos,double* newVel,double* newAccel,double* syncTime,double* reserved1,int* reserved2);
typedef int (__cdecl *ptrSimPushDoubleOntoStack)(int stackHandle,double value);
typedef int (__cdecl *ptrSimPushDoubleTableOntoStack)(int stackHandle,const double* values,int valueCnt);
typedef int (__cdecl *ptrSimGetStackDoubleValue)(int stackHandle,double* numberValue);
typedef int (__cdecl *ptrSimGetStackDoubleTable)(int stackHandle,double* array,int count);
/* Following courtesy of Stephen James: */
typedef int (__cdecl *ptrSimExtLaunchUIThread)(const char* applicationName,int options,const char* sceneOrModelOrUiToLoad,const char* applicationDir_);
typedef int (__cdecl *ptrSimExtCanInitSimThread)();
typedef int (__cdecl *ptrSimExtSimThreadInit)();
typedef int (__cdecl *ptrSimExtSimThreadDestroy)();
typedef int (__cdecl *ptrSimExtPostExitRequest)();
typedef int (__cdecl *ptrSimExtGetExitRequest)();
typedef int (__cdecl *ptrSimExtStep)(bool stepIfRunning);
/* non-documented functions, mainly for the dynamics plugins: */
typedef void (__cdecl *ptr_simSetDynamicSimulationIconCode)(void* object,int code);
typedef void (__cdecl *ptr_simSetDynamicObjectFlagForVisualization)(void* object,int flag);
typedef int (__cdecl *ptr_simGetObjectListSize)(int objType);
typedef const void* (__cdecl *ptr_simGetObjectFromIndex)(int objType,int index);
typedef int (__cdecl *ptr_simGetObjectID)(const void* object);
typedef int (__cdecl *ptr_simGetObjectType)(const void* object);
typedef const void** (__cdecl *ptr_simGetObjectChildren)(const void* object,int* count);
typedef const void* (__cdecl *ptr_simGetParentObject)(const void* object);
typedef const void* (__cdecl *ptr_simGetObject)(int objID);
typedef const void* (__cdecl *ptr_simGetIkGroupObject)(int ikGroupID);
typedef int (__cdecl *ptr_simMpHandleIkGroupObject)(const void* ikGroup);
typedef bool (__cdecl *ptr_simIsShapeDynamicallyStatic)(const void* shape);
typedef int (__cdecl *ptr_simGetTreeDynamicProperty)(const void* object);
typedef int (__cdecl *ptr_simGetDummyLinkType)(const void* dummy,int* linkedDummyID);
typedef int (__cdecl *ptr_simGetJointMode)(const void* joint);
typedef bool (__cdecl *ptr_simIsJointInHybridOperation)(const void* joint);
typedef void (__cdecl *ptr_simDisableDynamicTreeForManipulation)(const void* object,bool disableFlag);
typedef bool (__cdecl *ptr_simIsShapeDynamicallyRespondable)(const void* shape);
typedef int (__cdecl *ptr_simGetDynamicCollisionMask)(const void* shape);
typedef const void* (__cdecl *ptr_simGetLastParentForLocalGlobalCollidable)(const void* shape);
typedef bool (__cdecl *ptr_simGetStartSleeping)(const void* shape);
typedef bool (__cdecl *ptr_simGetWasPutToSleepOnce)(const void* shape);
typedef bool (__cdecl *ptr_simGetDynamicsFullRefreshFlag)(const void* object);
typedef void (__cdecl *ptr_simSetDynamicsFullRefreshFlag)(const void* object,bool flag);
typedef void (__cdecl *ptr_simClearAdditionalForceAndTorque)(const void* shape);
typedef int (__cdecl *ptr_simGetJointType)(const void* joint);
typedef const void* (__cdecl *ptr_simGetGeomWrapFromGeomProxy)(const void* geomData);
typedef int (__cdecl *ptr_simGetPurePrimitiveType)(const void* geomInfo);
typedef bool (__cdecl *ptr_simIsGeomWrapGeometric)(const void* geomInfo);
typedef bool (__cdecl *ptr_simIsGeomWrapConvex)(const void* geomInfo);
typedef int (__cdecl *ptr_simGetGeometricCount)(const void* geomInfo);
typedef void (__cdecl *ptr_simGetAllGeometrics)(const void* geomInfo,void** allGeometrics);
typedef void (__cdecl *ptr_simMakeDynamicAnnouncement)(int announceType);
typedef int (__cdecl *ptr_simGetTimeDiffInMs)(int previousTime);
typedef bool (__cdecl *ptr_simDoEntitiesCollide)(int entity1ID,int entity2ID,int* cacheBuffer,bool overrideCollidableFlagIfShape1,bool overrideCollidableFlagIfShape2,bool pathPlanningRoutineCalling);
typedef int (__cdecl *ptr_simGetJointDynCtrlMode)(const void* joint);
typedef int (__cdecl *ptrSimFloatingViewRemove)(int floatingViewHandle);
#ifdef interfaceIsSinglePrecision
typedef int (__cdecl *ptrSimGetShapeViz)(int shapeHandle,int index,struct SShapeVizInfof* info);
#else
typedef int (__cdecl *ptrSimGetShapeViz)(int shapeHandle,int index,struct SShapeVizInfo* info);
#endif
/* previously single precision functions: */
typedef int (__cdecl *ptrSimSetArrayParam)(int Param,const SIMDOUBLE* arrayOfValues);
typedef int (__cdecl *ptrSimGetArrayParam)(int Param,SIMDOUBLE* arrayOfValues);
typedef int (__cdecl *ptrSimSetFloatSignal)(const char* signalName,SIMDOUBLE signalValue);
typedef int (__cdecl *ptrSimGetFloatSignal)(const char* signalName,SIMDOUBLE* signalValue);
typedef int (__cdecl *ptrSimSetFloatParam)(int Param,SIMDOUBLE floatState);
typedef int (__cdecl *ptrSimGetFloatParam)(int Param,SIMDOUBLE* floatState);
typedef int (__cdecl *ptrSimGetObjectFloatParam)(int objectHandle,int parameterID,SIMDOUBLE* parameter);
typedef int (__cdecl *ptrSimSetObjectFloatParam)(int objectHandle,int parameterID,SIMDOUBLE parameter);
typedef SIMDOUBLE* (__cdecl *ptrSimGetObjectFloatArrayParam)(int objectHandle,int parameterID,int* size);
typedef int (__cdecl *ptrSimSetObjectFloatArrayParam)(int objectHandle,int parameterID,const SIMDOUBLE* params,int size);
typedef SIMDOUBLE (__cdecl *ptrSimGetEngineFloatParam)(int paramId,int objectHandle,const void* object,bool* ok);
typedef int (__cdecl *ptrSimSetEngineFloatParam)(int paramId,int objectHandle,const void* object,SIMDOUBLE val);
typedef int (__cdecl *ptrSimTransformImage)(unsigned char* image,const int* resolution,int options,const SIMDOUBLE* floatParams,const int* intParams,void* reserved);
typedef const SIMDOUBLE* (__cdecl *ptrSimGetOctreeVoxels)(int octreeHandle,int* ptCnt,void* reserved);
typedef const SIMDOUBLE* (__cdecl *ptrSimGetPointCloudPoints)(int pointCloudHandle,int* ptCnt,void* reserved);
typedef int (__cdecl *ptrSimGetObjectMatrix)(int objectHandle,int relativeToObjectHandle,SIMDOUBLE* matrix);
typedef int (__cdecl *ptrSimSetObjectMatrix)(int objectHandle,int relativeToObjectHandle,const SIMDOUBLE* matrix);
typedef int (__cdecl *ptrSimGetObjectPose)(int objectHandle,int relativeToObjectHandle,SIMDOUBLE* pose);
typedef int (__cdecl *ptrSimSetObjectPose)(int objectHandle,int relativeToObjectHandle,const SIMDOUBLE* pose);
typedef int (__cdecl *ptrSimGetObjectPosition)(int objectHandle,int relativeToObjectHandle,SIMDOUBLE* position);
typedef int (__cdecl *ptrSimSetObjectPosition)(int objectHandle,int relativeToObjectHandle,const SIMDOUBLE* position);
typedef int (__cdecl *ptrSimGetObjectOrientation)(int objectHandle,int relativeToObjectHandle,SIMDOUBLE* eulerAngles);
typedef int (__cdecl *ptrSimSetObjectOrientation)(int objectHandle,int relativeToObjectHandle,const SIMDOUBLE* eulerAngles);
typedef int (__cdecl *ptrSimGetJointPosition)(int objectHandle,SIMDOUBLE* position);
typedef int (__cdecl *ptrSimSetJointPosition)(int objectHandle,SIMDOUBLE position);
typedef int (__cdecl *ptrSimSetJointTargetPosition)(int objectHandle,SIMDOUBLE targetPosition);
typedef int (__cdecl *ptrSimGetJointTargetPosition)(int objectHandle,SIMDOUBLE* targetPosition);
typedef int (__cdecl *ptrSimGetJointTargetForce)(int jointHandle,SIMDOUBLE* forceOrTorque);
typedef int (__cdecl *ptrSimSetJointTargetForce)(int objectHandle,SIMDOUBLE forceOrTorque,bool signedValue);
typedef int (__cdecl *ptrSimGetObjectChildPose)(int objectHandle,SIMDOUBLE* pose);
typedef int (__cdecl *ptrSimSetObjectChildPose)(int objectHandle,const SIMDOUBLE* pose);
typedef int (__cdecl *ptrSimGetJointInterval)(int objectHandle,bool* cyclic,SIMDOUBLE* interval);
typedef int (__cdecl *ptrSimSetJointInterval)(int objectHandle,bool cyclic,const SIMDOUBLE* interval);
typedef int (__cdecl *ptrSimBuildIdentityMatrix)(SIMDOUBLE* matrix);
typedef int (__cdecl *ptrSimBuildMatrix)(const SIMDOUBLE* position,const SIMDOUBLE* eulerAngles,SIMDOUBLE* matrix);
typedef int (__cdecl *ptrSimBuildPose)(const SIMDOUBLE* position,const SIMDOUBLE* eulerAngles,SIMDOUBLE* pose);
typedef int (__cdecl *ptrSimGetEulerAnglesFromMatrix)(const SIMDOUBLE* matrix,SIMDOUBLE* eulerAngles);
typedef int (__cdecl *ptrSimInvertMatrix)(SIMDOUBLE* matrix);
typedef int (__cdecl *ptrSimMultiplyMatrices)(const SIMDOUBLE* matrixIn1,const SIMDOUBLE* matrixIn2,SIMDOUBLE* matrixOut);
typedef int (__cdecl *ptrSimMultiplyPoses)(const SIMDOUBLE* poseIn1,const SIMDOUBLE* poseIn2,SIMDOUBLE* poseOut);
typedef int (__cdecl *ptrSimInvertPose)(SIMDOUBLE* pose);
typedef int (__cdecl *ptrSimInterpolatePoses)(const SIMDOUBLE* poseIn1,const SIMDOUBLE* poseIn2,SIMDOUBLE interpolFactor,SIMDOUBLE* poseOut);
typedef int (__cdecl *ptrSimPoseToMatrix)(const SIMDOUBLE* poseIn,SIMDOUBLE* matrixOut);
typedef int (__cdecl *ptrSimMatrixToPose)(const SIMDOUBLE* matrixIn,SIMDOUBLE* poseOut);
typedef int (__cdecl *ptrSimInterpolateMatrices)(const SIMDOUBLE* matrixIn1,const SIMDOUBLE* matrixIn2,SIMDOUBLE interpolFactor,SIMDOUBLE* matrixOut);
typedef int (__cdecl *ptrSimTransformVector)(const SIMDOUBLE* matrix,SIMDOUBLE* vect);
typedef SIMDOUBLE (__cdecl *ptrSimGetSimulationTime)();
typedef SIMDOUBLE (__cdecl *ptrSimGetSystemTime)();
typedef int (__cdecl *ptrSimHandleProximitySensor)(int sensorHandle,SIMDOUBLE* detectedPoint,int* detectedObjectHandle,SIMDOUBLE* normalVector);
typedef int (__cdecl *ptrSimReadProximitySensor)(int sensorHandle,SIMDOUBLE* detectedPoint,int* detectedObjectHandle,SIMDOUBLE* normalVector);
typedef int (__cdecl *ptrSimHandleDynamics)(SIMDOUBLE deltaTime);
typedef int (__cdecl *ptrSimCheckProximitySensor)(int sensorHandle,int entityHandle,SIMDOUBLE* detectedPoint);
typedef int (__cdecl *ptrSimCheckProximitySensorEx)(int sensorHandle,int entityHandle,int detectionMode,SIMDOUBLE detectionThreshold,SIMDOUBLE maxAngle,SIMDOUBLE* detectedPoint,int* detectedObjectHandle,SIMDOUBLE* normalVector);
typedef int (__cdecl *ptrSimCheckProximitySensorEx2)(int sensorHandle,SIMDOUBLE* vertexPointer,int itemType,int itemCount,int detectionMode,SIMDOUBLE detectionThreshold,SIMDOUBLE maxAngle,SIMDOUBLE* detectedPoint,SIMDOUBLE* normalVector);
typedef int (__cdecl *ptrSimCheckCollisionEx)(int entity1Handle,int entity2Handle,SIMDOUBLE** intersectionSegments);
typedef int (__cdecl *ptrSimCheckDistance)(int entity1Handle,int entity2Handle,SIMDOUBLE threshold,SIMDOUBLE* distanceData);
typedef int (__cdecl *ptrSimSetSimulationTimeStep)(SIMDOUBLE timeStep);
typedef SIMDOUBLE (__cdecl *ptrSimGetSimulationTimeStep)();
typedef int (__cdecl *ptrSimAdjustRealTimeTimer)(int instanceIndex,SIMDOUBLE deltaTime);
typedef int (__cdecl *ptrSimFloatingViewAdd)(SIMDOUBLE posX,SIMDOUBLE posY,SIMDOUBLE sizeX,SIMDOUBLE sizeY,int options);
typedef int (__cdecl *ptrSimHandleGraph)(int graphHandle,SIMDOUBLE simulationTime);
typedef int (__cdecl *ptrSimSetGraphStreamTransformation)(int graphHandle,int streamId,int trType,SIMDOUBLE mult,SIMDOUBLE off,int movingAvgPeriod);
typedef int (__cdecl *ptrSimAddGraphCurve)(int graphHandle,const char* curveName,int dim,const int* streamIds,const SIMDOUBLE* defaultValues,const char* unitStr,int options,const float* color,int curveWidth);
typedef int (__cdecl *ptrSimSetGraphStreamValue)(int graphHandle,int streamId,SIMDOUBLE value);
typedef int (__cdecl *ptrSimSetJointTargetVelocity)(int objectHandle,SIMDOUBLE targetVelocity);
typedef int (__cdecl *ptrSimGetJointTargetVelocity)(int objectHandle,SIMDOUBLE* targetVelocity);
typedef int (__cdecl *ptrSimScaleObjects)(const int* objectHandles,int objectCount,SIMDOUBLE scalingFactor,bool scalePositionsToo);
typedef int (__cdecl *ptrSimAddDrawingObject)(int objectType,SIMDOUBLE size,SIMDOUBLE duplicateTolerance,int parentObjectHandle,int maxItemCount,const float* color,const float* setToNULL,const float* setToNULL2,const float* setToNULL3);
typedef int (__cdecl *ptrSimAddGraphStream)(int graphHandle,const char* streamName,const char* unitStr,int options,const float* color,SIMDOUBLE cyclicRange);
typedef int (__cdecl *ptrSimAddDrawingObjectItem)(int objectHandle,const SIMDOUBLE* itemData);
typedef SIMDOUBLE (__cdecl *ptrSimGetObjectSizeFactor)(int objectHandle);
typedef int (__cdecl *ptrSimReadForceSensor)(int objectHandle,SIMDOUBLE* forceVector,SIMDOUBLE* torqueVector);
typedef int (__cdecl *ptrSimSetLightParameters)(int objectHandle,int state,const float* setToNULL,const float* diffusePart,const float* specularPart);
typedef int (__cdecl *ptrSimGetLightParameters)(int objectHandle,SIMDOUBLE* setToNULL,SIMDOUBLE* diffusePart,SIMDOUBLE* specularPart);
typedef int (__cdecl *ptrSimGetVelocity)(int shapeHandle,SIMDOUBLE* linearVelocity,SIMDOUBLE* angularVelocity);
typedef int (__cdecl *ptrSimGetObjectVelocity)(int objectHandle,SIMDOUBLE* linearVelocity,SIMDOUBLE* angularVelocity);
typedef int (__cdecl *ptrSimGetJointVelocity)(int jointHandle,SIMDOUBLE* velocity);
typedef int (__cdecl *ptrSimAddForceAndTorque)(int shapeHandle,const SIMDOUBLE* force,const SIMDOUBLE* torque);
typedef int (__cdecl *ptrSimAddForce)(int shapeHandle,const SIMDOUBLE* position,const SIMDOUBLE* force);
typedef int (__cdecl *ptrSimSetObjectColor)(int objectHandle,int index,int colorComponent,const float* rgbData);
typedef int (__cdecl *ptrSimGetObjectColor)(int objectHandle,int index,int colorComponent,float* rgbData);
typedef int (__cdecl *ptrSimSetShapeColor)(int shapeHandle,const char* colorName,int colorComponent,const float* rgbData);
typedef int (__cdecl *ptrSimGetShapeColor)(int shapeHandle,const char* colorName,int colorComponent,float* rgbData);
typedef int (__cdecl *ptrSimGetContactInfo)(int dynamicPass,int objectHandle,int index,int* objectHandles,SIMDOUBLE* contactInfo);
typedef int (__cdecl *ptrSimAuxiliaryConsoleOpen)(const char* title,int maxLines,int mode,const int* position,const int* size,const float* textColor,const float* backgroundColor);
typedef int (__cdecl *ptrSimImportShape)(int fileformat,const char* pathAndFilename,int options,SIMDOUBLE identicalVerticeTolerance,SIMDOUBLE scalingFactor);
typedef int (__cdecl *ptrSimImportMesh)(int fileformat,const char* pathAndFilename,int options,SIMDOUBLE identicalVerticeTolerance,SIMDOUBLE scalingFactor,SIMDOUBLE*** vertices,int** verticesSizes,int*** indices,int** indicesSizes,SIMDOUBLE*** reserved,char*** names);
typedef int (__cdecl *ptrSimExportMesh)(int fileformat,const char* pathAndFilename,int options,SIMDOUBLE scalingFactor,int elementCount,const SIMDOUBLE** vertices,const int* verticesSizes,const int** indices,const int* indicesSizes,SIMDOUBLE** reserved,const char** names);
typedef int (__cdecl *ptrSimCreateShape)(int options,double shadingAngle,const double* vertices,int verticesSize,const int* indices,int indicesSize,const double* normals,const float* textCoords,const unsigned char* texture,const int* textureResolution);
typedef int (__cdecl *ptrSimCreateMeshShape)(int options,SIMDOUBLE shadingAngle,const SIMDOUBLE* vertices,int verticesSize,const int* indices,int indicesSize,SIMDOUBLE* reserved);
typedef int (__cdecl *ptrSimCreatePrimitiveShape)(int primitiveType,const SIMDOUBLE* sizes,int options);
typedef int (__cdecl *ptrSimCreateHeightfieldShape)(int options,SIMDOUBLE shadingAngle,int xPointCount,int yPointCount,SIMDOUBLE xSize,const SIMDOUBLE* heights);
typedef int (__cdecl *ptrSimGetShapeMesh)(int shapeHandle,SIMDOUBLE** vertices,int* verticesSize,int** indices,int* indicesSize,SIMDOUBLE** normals);
typedef int (__cdecl *ptrSimCreateJoint)(int jointType,int jointMode,int options,const SIMDOUBLE* sizes,const SIMDOUBLE* reservedA,const SIMDOUBLE* reservedB);
typedef int (__cdecl *ptrSimCreateDummy)(SIMDOUBLE size,const float* reserved);
typedef int (__cdecl *ptrSimCreateForceSensor)(int options,const int* intParams,const SIMDOUBLE* floatParams,const SIMDOUBLE* reserved);
typedef int (__cdecl *ptrSimCreateVisionSensor)(int options,const int* intParams,const SIMDOUBLE* floatParams,const SIMDOUBLE* reserved);
typedef int (__cdecl *ptrSimCreateProximitySensor)(int sensorType,int subType,int options,const int* intParams,const SIMDOUBLE* floatParams,const SIMDOUBLE* reserved);
typedef int (__cdecl *ptrSimGetRotationAxis)(const SIMDOUBLE* matrixStart,const SIMDOUBLE* matrixGoal,SIMDOUBLE* axis,SIMDOUBLE* angle);
typedef int (__cdecl *ptrSimRotateAroundAxis)(const SIMDOUBLE* matrixIn,const SIMDOUBLE* axis,const SIMDOUBLE* axisPos,SIMDOUBLE angle,SIMDOUBLE* matrixOut);
typedef int (__cdecl *ptrSimGetJointForce)(int jointHandle,SIMDOUBLE* forceOrTorque);
typedef int (__cdecl *ptrSimCameraFitToView)(int viewHandleOrIndex,int objectCount,const int* objectHandles,int options,SIMDOUBLE scaling);
typedef int (__cdecl *ptrSimHandleVisionSensor)(int visionSensorHandle,SIMDOUBLE** auxValues,int** auxValuesCount);
typedef int (__cdecl *ptrSimReadVisionSensor)(int visionSensorHandle,SIMDOUBLE** auxValues,int** auxValuesCount);
typedef int (__cdecl *ptrSimCheckVisionSensor)(int visionSensorHandle,int entityHandle,SIMDOUBLE** auxValues,int** auxValuesCount);
typedef unsigned char* (__cdecl *ptrSimGetVisionSensorImg)(int sensorHandle,int options,SIMDOUBLE rgbaCutOff,const int* pos,const int* size,int* resolution);
typedef int (__cdecl *ptrSimGetVisionSensorRes)(int visionSensorHandle,int* resolution);
typedef int (__cdecl *ptrSimGetObjectQuaternion)(int objectHandle,int relativeToObjectHandle,SIMDOUBLE* quaternion);
typedef int (__cdecl *ptrSimSetObjectQuaternion)(int objectHandle,int relativeToObjectHandle,const SIMDOUBLE* quaternion);
typedef int (__cdecl *ptrSimConvexDecompose)(int shapeHandle,int options,const int* intParams,const SIMDOUBLE* floatParams);
typedef int (__cdecl *ptrSimWriteTexture)(int textureId,int options,const char* data,int posX,int posY,int sizeX,int sizeY,SIMDOUBLE interpol);
typedef int (__cdecl *ptrSimCreateTexture)(const char* fileName,int options,const SIMDOUBLE* planeSizes,const SIMDOUBLE* scalingUV,const SIMDOUBLE* xy_g,int fixedResolution,int* textureId,int* resolution,const void* reserved);
typedef int (__cdecl *ptrSimGetShapeGeomInfo)(int shapeHandle,int* intData,SIMDOUBLE* floatData,void* reserved);
typedef int (__cdecl *ptrSimScaleObject)(int objectHandle,SIMDOUBLE xScale,SIMDOUBLE yScale,SIMDOUBLE zScale,int options);
typedef int (__cdecl *ptrSimSetShapeTexture)(int shapeHandle,int textureId,int mappingMode,int options,const SIMDOUBLE* uvScaling,const SIMDOUBLE* position,const SIMDOUBLE* orientation);
typedef int (__cdecl *ptrSimGetQHull)(const SIMDOUBLE* inVertices,int inVerticesL,SIMDOUBLE** verticesOut,int* verticesOutL,int** indicesOut,int* indicesOutL,int reserved1,const SIMDOUBLE* reserved2);
typedef int (__cdecl *ptrSimGetDecimatedMesh)(const SIMDOUBLE* inVertices,int inVerticesL,const int* inIndices,int inIndicesL,SIMDOUBLE** verticesOut,int* verticesOutL,int** indicesOut,int* indicesOutL,SIMDOUBLE decimationPercent,int reserved1,const SIMDOUBLE* reserved2);
typedef int (__cdecl *ptrSimComputeMassAndInertia)(int shapeHandle,SIMDOUBLE density);
typedef int (__cdecl *ptrSimCreateOctree)(SIMDOUBLE voxelSize,int options,SIMDOUBLE pointSize,void* reserved);
typedef int (__cdecl *ptrSimCreatePointCloud)(SIMDOUBLE maxVoxelSize,int maxPtCntPerVoxel,int options,SIMDOUBLE pointSize,void* reserved);
typedef int (__cdecl *ptrSimSetPointCloudOptions)(int pointCloudHandle,SIMDOUBLE maxVoxelSize,int maxPtCntPerVoxel,int options,SIMDOUBLE pointSize,void* reserved);
typedef int (__cdecl *ptrSimGetPointCloudOptions)(int pointCloudHandle,SIMDOUBLE* maxVoxelSize,int* maxPtCntPerVoxel,int* options,SIMDOUBLE* pointSize,void* reserved);
typedef int (__cdecl *ptrSimInsertVoxelsIntoOctree)(int octreeHandle,int options,const SIMDOUBLE* pts,int ptCnt,const unsigned char* color,const unsigned int* tag,void* reserved);
typedef int (__cdecl *ptrSimRemoveVoxelsFromOctree)(int octreeHandle,int options,const SIMDOUBLE* pts,int ptCnt,void* reserved);
typedef int (__cdecl *ptrSimInsertPointsIntoPointCloud)(int pointCloudHandle,int options,const SIMDOUBLE* pts,int ptCnt,const unsigned char* color,void* optionalValues);
typedef int (__cdecl *ptrSimRemovePointsFromPointCloud)(int pointCloudHandle,int options,const SIMDOUBLE* pts,int ptCnt,SIMDOUBLE tolerance,void* reserved);
typedef int (__cdecl *ptrSimIntersectPointsWithPointCloud)(int pointCloudHandle,int options,const SIMDOUBLE* pts,int ptCnt,SIMDOUBLE tolerance,void* reserved);
typedef int (__cdecl *ptrSimInsertObjectIntoPointCloud)(int pointCloudHandle,int objectHandle,int options,SIMDOUBLE gridSize,const unsigned char* color,void* optionalValues);
typedef int (__cdecl *ptrSimSubtractObjectFromPointCloud)(int pointCloudHandle,int objectHandle,int options,SIMDOUBLE tolerance,void* reserved);
typedef int (__cdecl *ptrSimCheckOctreePointOccupancy)(int octreeHandle,int options,const SIMDOUBLE* points,int ptCnt,unsigned int* tag,unsigned long long int* location,void* reserved);
typedef int (__cdecl *ptrSimApplyTexture)(int shapeHandle,const SIMDOUBLE* textureCoordinates,int textCoordSize,const unsigned char* texture,const int* textureResolution,int options);
typedef int (__cdecl *ptrSimSetJointDependency)(int jointHandle,int masterJointHandle,SIMDOUBLE offset,SIMDOUBLE multCoeff);
typedef int (__cdecl *ptrSimGetJointDependency)(int jointHandle,int* masterJointHandle,SIMDOUBLE* offset,SIMDOUBLE* multCoeff);
typedef int (__cdecl *ptrSimGetShapeMass)(int shapeHandle,SIMDOUBLE* mass);
typedef int (__cdecl *ptrSimSetShapeMass)(int shapeHandle,SIMDOUBLE mass);
typedef int (__cdecl *ptrSimGetShapeInertia)(int shapeHandle,SIMDOUBLE* inertiaMatrix,SIMDOUBLE* transformationMatrix);
typedef int (__cdecl *ptrSimSetShapeInertia)(int shapeHandle,const SIMDOUBLE* inertiaMatrix,const SIMDOUBLE* transformationMatrix);
typedef int (__cdecl *ptrSimGenerateShapeFromPath)(const SIMDOUBLE* path,int pathSize,const SIMDOUBLE* section,int sectionSize,int options,const SIMDOUBLE* upVector,SIMDOUBLE reserved);
typedef SIMDOUBLE (__cdecl *ptrSimGetClosestPosOnPath)(const SIMDOUBLE* path,int pathSize,const SIMDOUBLE* pathLengths,const SIMDOUBLE* absPt);
typedef int (__cdecl *ptrSimExtCallScriptFunction)(int scriptHandleOrType, const char* functionNameAtScriptName,const int* inIntData, int inIntCnt,const SIMDOUBLE* inFloatData, int inFloatCnt,const char** inStringData, int inStringCnt,const char* inBufferData, int inBufferCnt,int** outIntData, int* outIntCnt,SIMDOUBLE** outFloatData, int* outFloatCnt,char*** outStringData, int* outStringCnt,char** outBufferData, int* outBufferSize);
typedef void (__cdecl *ptr_simGetObjectLocalTransformation)(const void* object,SIMDOUBLE* pos,SIMDOUBLE* quat,bool excludeFirstJointTransformation);
typedef void (__cdecl *ptr_simSetObjectLocalTransformation)(void* object,const SIMDOUBLE* pos,const SIMDOUBLE* quat,SIMDOUBLE simTime);
typedef void (__cdecl *ptr_simDynReportObjectCumulativeTransformation)(void* object,const SIMDOUBLE* pos,const SIMDOUBLE* quat,SIMDOUBLE simTime);
typedef void (__cdecl *ptr_simSetObjectCumulativeTransformation)(void* object,const SIMDOUBLE* pos,const SIMDOUBLE* quat,bool keepChildrenInPlace);
typedef void (__cdecl *ptr_simGetObjectCumulativeTransformation)(const void* object,SIMDOUBLE* pos,SIMDOUBLE* quat,bool excludeFirstJointTransformation);
typedef void (__cdecl *ptr_simSetJointVelocity)(const void* joint,SIMDOUBLE vel);
typedef void (__cdecl *ptr_simSetJointPosition)(const void* joint,SIMDOUBLE pos);
typedef SIMDOUBLE (__cdecl *ptr_simGetJointPosition)(const void* joint);
typedef void (__cdecl *ptr_simSetDynamicMotorPositionControlTargetPosition)(const void* joint,SIMDOUBLE pos);
typedef void (__cdecl *ptr_simGetInitialDynamicVelocity)(const void* shape,SIMDOUBLE* vel);
typedef void (__cdecl *ptr_simSetInitialDynamicVelocity)(void* shape,const SIMDOUBLE* vel);
typedef void (__cdecl *ptr_simGetInitialDynamicAngVelocity)(const void* shape,SIMDOUBLE* angularVel);
typedef void (__cdecl *ptr_simSetInitialDynamicAngVelocity)(void* shape,const SIMDOUBLE* angularVel);
typedef void (__cdecl *ptr_simSetShapeDynamicVelocity)(void* shape,const SIMDOUBLE* linear,const SIMDOUBLE* angular,SIMDOUBLE simTime);
typedef void (__cdecl *ptr_simGetAdditionalForceAndTorque)(const void* shape,SIMDOUBLE* force,SIMDOUBLE* torque);
typedef bool (__cdecl *ptr_simGetJointPositionInterval)(const void* joint,SIMDOUBLE* minValue,SIMDOUBLE* rangeValue);
typedef SIMDOUBLE (__cdecl *ptr_simGetDynamicMotorTargetPosition)(const void* joint);
typedef SIMDOUBLE (__cdecl *ptr_simGetDynamicMotorTargetVelocity)(const void* joint);
typedef SIMDOUBLE (__cdecl *ptr_simGetDynamicMotorMaxForce)(const void* joint);
typedef SIMDOUBLE (__cdecl *ptr_simGetDynamicMotorUpperLimitVelocity)(const void* joint);
typedef void (__cdecl *ptr_simSetDynamicMotorReflectedPositionFromDynamicEngine)(void* joint,SIMDOUBLE pos,SIMDOUBLE simTime);
typedef void (__cdecl *ptr_simSetJointSphericalTransformation)(void* joint,const SIMDOUBLE* quat,SIMDOUBLE simTime);
typedef void (__cdecl *ptr_simAddForceSensorCumulativeForcesAndTorques)(void* forceSensor,const SIMDOUBLE* force,const SIMDOUBLE* torque,int totalPassesCount,SIMDOUBLE simTime);
typedef void (__cdecl *ptr_simAddJointCumulativeForcesOrTorques)(void* joint,SIMDOUBLE forceOrTorque,int totalPassesCount,SIMDOUBLE simTime);
typedef SIMDOUBLE (__cdecl *ptr_simGetMass)(const void* geomInfo);
typedef SIMDOUBLE (__cdecl *ptr_simGetLocalInertiaInfo)(const void* object,SIMDOUBLE* pos,SIMDOUBLE* quat,SIMDOUBLE* diagI);
typedef void (__cdecl *ptr_simGetPurePrimitiveSizes)(const void* geometric,SIMDOUBLE* sizes);
typedef void (__cdecl *ptr_simGetVerticesLocalFrame)(const void* shape,const void* geometric,SIMDOUBLE* pos,SIMDOUBLE* quat);
typedef const SIMDOUBLE* (__cdecl *ptr_simGetHeightfieldData)(const void* geometric,int* xCount,int* yCount,SIMDOUBLE* minHeight,SIMDOUBLE* maxHeight);
typedef void (__cdecl *ptr_simGetCumulativeMeshes)(const void* shape,const void* geomInfo,SIMDOUBLE** vertices,int* verticesSize,int** indices,int* indicesSize);
typedef void (__cdecl *ptr_simGetGravity)(SIMDOUBLE* gravity);
typedef bool (__cdecl *ptr_simGetDistanceBetweenEntitiesIfSmaller)(int entity1ID,int entity2ID,SIMDOUBLE* distance,SIMDOUBLE* ray,int* cacheBuffer,bool overrideMeasurableFlagIfNonCollection1,bool overrideMeasurableFlagIfNonCollection2,bool pathPlanningRoutineCalling);
typedef int (__cdecl *ptr_simHandleJointControl)(const void* joint,int auxV,const int* inputValuesInt,const SIMDOUBLE* inputValuesFloat,SIMDOUBLE* outputValues);
typedef int (__cdecl *ptr_simHandleCustomContact)(int objHandle1,int objHandle2,int engine,int* dataInt,SIMDOUBLE* dataFloat);
typedef SIMDOUBLE (__cdecl *ptr_simGetPureHollowScaling)(const void* geometric);
typedef void (__cdecl *ptr_simDynCallback)(const int* intData,const SIMDOUBLE* floatData);


extern ptrSimRunSimulator simRunSimulator;
extern ptrSimRunSimulatorEx simRunSimulatorEx;
extern ptrSimGetSimulatorMessage simGetSimulatorMessage;
extern ptrSimGetMainWindow simGetMainWindow;
extern ptrSimGetLastError simGetLastError;
extern ptrSimLoadModule simLoadModule;
extern ptrSimUnloadModule simUnloadModule;
extern ptrSimSetBoolParam simSetBoolParam;
extern ptrSimGetBoolParam simGetBoolParam;
extern ptrSimSetInt32Param simSetInt32Param;
extern ptrSimGetInt32Param simGetInt32Param;
extern ptrSimGetUInt64Param simGetUInt64Param;
extern ptrSimSetFloatParam simSetFloatParam;
extern ptrSimGetFloatParam simGetFloatParam;
extern ptrSimSetStringParam simSetStringParam;
extern ptrSimGetStringParam simGetStringParam;
extern ptrSimSetArrayParam simSetArrayParam;
extern ptrSimGetArrayParam simGetArrayParam;
extern ptrSimSetNamedStringParam simSetNamedStringParam;
extern ptrSimGetNamedStringParam simGetNamedStringParam;
extern ptrSimGetObject simGetObject;
extern ptrSimGetObjectUid simGetObjectUid;
extern ptrSimGetObjectFromUid simGetObjectFromUid;
extern ptrSimGetScriptHandleEx simGetScriptHandleEx;
extern ptrSimRemoveObjects simRemoveObjects;
extern ptrSimRemoveModel simRemoveModel;
extern ptrSimGetObjectAlias simGetObjectAlias;
extern ptrSimSetObjectAlias simSetObjectAlias;
extern ptrSimGetObjectMatrix simGetObjectMatrix;
extern ptrSimSetObjectMatrix simSetObjectMatrix;
extern ptrSimGetObjectPose simGetObjectPose;
extern ptrSimSetObjectPose simSetObjectPose;
extern ptrSimGetObjectPosition simGetObjectPosition;
extern ptrSimSetObjectPosition simSetObjectPosition;
extern ptrSimGetObjectOrientation simGetObjectOrientation;
extern ptrSimSetObjectOrientation simSetObjectOrientation;
extern ptrSimGetJointPosition simGetJointPosition;
extern ptrSimSetJointPosition simSetJointPosition;
extern ptrSimSetJointTargetPosition simSetJointTargetPosition;
extern ptrSimGetJointTargetPosition simGetJointTargetPosition;
extern ptrSimGetObjectChildPose simGetObjectChildPose;
extern ptrSimSetObjectChildPose simSetObjectChildPose;
extern ptrSimGetJointInterval simGetJointInterval;
extern ptrSimSetJointInterval simSetJointInterval;
extern ptrSimGetObjectParent simGetObjectParent;
extern ptrSimGetObjectChild simGetObjectChild;
extern ptrSimSetObjectParent simSetObjectParent;
extern ptrSimGetObjectType simGetObjectType;
extern ptrSimGetJointType simGetJointType;
extern ptrSimBuildIdentityMatrix simBuildIdentityMatrix;
extern ptrSimBuildMatrix simBuildMatrix;
extern ptrSimBuildPose simBuildPose;
extern ptrSimGetEulerAnglesFromMatrix simGetEulerAnglesFromMatrix;
extern ptrSimInvertMatrix simInvertMatrix;
extern ptrSimMultiplyMatrices simMultiplyMatrices;
extern ptrSimMultiplyPoses simMultiplyPoses;
extern ptrSimInvertPose simInvertPose;
extern ptrSimInterpolatePoses simInterpolatePoses;
extern ptrSimPoseToMatrix simPoseToMatrix;
extern ptrSimMatrixToPose simMatrixToPose;
extern ptrSimInterpolateMatrices simInterpolateMatrices;
extern ptrSimTransformVector simTransformVector;
extern ptrSimReservedCommand simReservedCommand;
extern ptrSimGetSimulationTime simGetSimulationTime;
extern ptrSimGetSimulationState simGetSimulationState;
extern ptrSimGetSystemTime simGetSystemTime;
extern ptrSimLoadScene simLoadScene;
extern ptrSimCloseScene simCloseScene;
extern ptrSimSaveScene simSaveScene;
extern ptrSimLoadModel simLoadModel;
extern ptrSimSaveModel simSaveModel;
extern ptrSimDoesFileExist simDoesFileExist;
extern ptrSimGetObjectSel simGetObjectSel;
extern ptrSimSetObjectSel simSetObjectSel;
extern ptrSimHandleProximitySensor simHandleProximitySensor;
extern ptrSimReadProximitySensor simReadProximitySensor;
extern ptrSimHandleDynamics simHandleDynamics;
extern ptrSimAssociateScriptWithObject simAssociateScriptWithObject;
extern ptrSimHandleMainScript simHandleMainScript;
extern ptrSimResetScript simResetScript;
extern ptrSimAddScript simAddScript;
extern ptrSimRemoveScript simRemoveScript;
extern ptrSimRefreshDialogs simRefreshDialogs;
extern ptrSimResetProximitySensor simResetProximitySensor;
extern ptrSimCheckProximitySensor simCheckProximitySensor;
extern ptrSimCheckProximitySensorEx simCheckProximitySensorEx;
extern ptrSimCheckProximitySensorEx2 simCheckProximitySensorEx2;
extern ptrSimCreateBuffer simCreateBuffer;
extern ptrSimReleaseBuffer simReleaseBuffer;
extern ptrSimCheckCollision simCheckCollision;
extern ptrSimCheckCollisionEx simCheckCollisionEx;
extern ptrSimCheckDistance simCheckDistance;
extern ptrSimSetSimulationTimeStep simSetSimulationTimeStep;
extern ptrSimGetSimulationTimeStep simGetSimulationTimeStep;
extern ptrSimGetRealTimeSimulation simGetRealTimeSimulation;
extern ptrSimIsRealTimeSimulationStepNeeded simIsRealTimeSimulationStepNeeded;
extern ptrSimAdjustRealTimeTimer simAdjustRealTimeTimer;
extern ptrSimGetSimulationPassesPerRenderingPass simGetSimulationPassesPerRenderingPass;
extern ptrSimAdvanceSimulationByOneStep simAdvanceSimulationByOneStep;
extern ptrSimStartSimulation simStartSimulation;
extern ptrSimStopSimulation simStopSimulation;
extern ptrSimPauseSimulation simPauseSimulation;
extern ptrSimGetModuleName simGetModuleName;
extern ptrSimFloatingViewAdd simFloatingViewAdd;
extern ptrSimFloatingViewRemove simFloatingViewRemove;
extern ptrSimAdjustView simAdjustView;
extern ptrSimSetLastError simSetLastError;
extern ptrSimHandleGraph simHandleGraph;
extern ptrSimResetGraph simResetGraph;
extern ptrSimAddGraphStream simAddGraphStream;
extern ptrSimDestroyGraphCurve simDestroyGraphCurve;
extern ptrSimSetGraphStreamTransformation simSetGraphStreamTransformation;
extern ptrSimDuplicateGraphCurveToStatic simDuplicateGraphCurveToStatic;
extern ptrSimAddGraphCurve simAddGraphCurve;
extern ptrSimSetGraphStreamValue simSetGraphStreamValue;
extern ptrSimSetNavigationMode simSetNavigationMode;
extern ptrSimGetNavigationMode simGetNavigationMode;
extern ptrSimSetPage simSetPage;
extern ptrSimGetPage simGetPage;
extern ptrSimRegisterScriptCallbackFunction simRegisterScriptCallbackFunction;
extern ptrSimRegisterScriptVariable simRegisterScriptVariable;
extern ptrSimRegisterScriptFuncHook simRegisterScriptFuncHook;
extern ptrSimSetJointTargetVelocity simSetJointTargetVelocity;
extern ptrSimGetJointTargetVelocity simGetJointTargetVelocity;
extern ptrSimCopyPasteObjects simCopyPasteObjects;
extern ptrSimScaleObjects simScaleObjects;
extern ptrSimAddDrawingObject simAddDrawingObject;
extern ptrSimRemoveDrawingObject simRemoveDrawingObject;
extern ptrSimAddDrawingObjectItem simAddDrawingObjectItem;
extern ptrSimGetObjectSizeFactor simGetObjectSizeFactor;
extern ptrSimAnnounceSceneContentChange simAnnounceSceneContentChange;
extern ptrSimSetInt32Signal simSetInt32Signal;
extern ptrSimGetInt32Signal simGetInt32Signal;
extern ptrSimClearInt32Signal simClearInt32Signal;
extern ptrSimSetFloatSignal simSetFloatSignal;
extern ptrSimGetFloatSignal simGetFloatSignal;
extern ptrSimClearFloatSignal simClearFloatSignal;
extern ptrSimSetStringSignal simSetStringSignal;
extern ptrSimGetStringSignal simGetStringSignal;
extern ptrSimClearStringSignal simClearStringSignal;
extern ptrSimGetSignalName simGetSignalName;
extern ptrSimSetObjectProperty simSetObjectProperty;
extern ptrSimGetObjectProperty simGetObjectProperty;
extern ptrSimSetObjectSpecialProperty simSetObjectSpecialProperty;
extern ptrSimGetObjectSpecialProperty simGetObjectSpecialProperty;
extern ptrSimReadForceSensor simReadForceSensor;
extern ptrSimSetLightParameters simSetLightParameters;
extern ptrSimGetLightParameters simGetLightParameters;
extern ptrSimGetVelocity simGetVelocity;
extern ptrSimGetObjectVelocity simGetObjectVelocity;
extern ptrSimGetJointVelocity simGetJointVelocity;
extern ptrSimAddForceAndTorque simAddForceAndTorque;
extern ptrSimAddForce simAddForce;
extern ptrSimSetExplicitHandling simSetExplicitHandling;
extern ptrSimGetExplicitHandling simGetExplicitHandling;
extern ptrSimGetLinkDummy simGetLinkDummy;
extern ptrSimSetLinkDummy simSetLinkDummy;
extern ptrSimSetModelProperty simSetModelProperty;
extern ptrSimGetModelProperty simGetModelProperty;
extern ptrSimSetObjectColor simSetObjectColor;
extern ptrSimGetObjectColor simGetObjectColor;
extern ptrSimSetShapeColor simSetShapeColor;
extern ptrSimGetShapeColor simGetShapeColor;
extern ptrSimResetDynamicObject simResetDynamicObject;
extern ptrSimSetJointMode simSetJointMode;
extern ptrSimGetJointMode simGetJointMode;
extern ptrSimSerialOpen simSerialOpen;
extern ptrSimSerialClose simSerialClose;
extern ptrSimSerialSend simSerialSend;
extern ptrSimSerialRead simSerialRead;
extern ptrSimSerialCheck simSerialCheck;
extern ptrSimGetContactInfo simGetContactInfo;
extern ptrSimAuxiliaryConsoleOpen simAuxiliaryConsoleOpen;
extern ptrSimAuxiliaryConsoleClose simAuxiliaryConsoleClose;
extern ptrSimAuxiliaryConsoleShow simAuxiliaryConsoleShow;
extern ptrSimAuxiliaryConsolePrint simAuxiliaryConsolePrint;
extern ptrSimImportShape simImportShape;
extern ptrSimImportMesh simImportMesh;
extern ptrSimExportMesh simExportMesh;
extern ptrSimCreateShape simCreateShape;
extern ptrSimCreateMeshShape simCreateMeshShape;
extern ptrSimCreatePrimitiveShape simCreatePrimitiveShape;
extern ptrSimCreateHeightfieldShape simCreateHeightfieldShape;
extern ptrSimGetShapeMesh simGetShapeMesh;
extern ptrSimCreateJoint simCreateJoint;
extern ptrSimCreateDummy simCreateDummy;
extern ptrSimCreateForceSensor simCreateForceSensor;
extern ptrSimCreateVisionSensor simCreateVisionSensor;
extern ptrSimCreateProximitySensor simCreateProximitySensor;
extern ptrSimGetObjectInt32Param simGetObjectInt32Param;
extern ptrSimSetObjectInt32Param simSetObjectInt32Param;
extern ptrSimGetObjectFloatParam simGetObjectFloatParam;
extern ptrSimSetObjectFloatParam simSetObjectFloatParam;
extern ptrSimGetObjectFloatArrayParam simGetObjectFloatArrayParam;
extern ptrSimSetObjectFloatArrayParam simSetObjectFloatArrayParam;
extern ptrSimGetObjectStringParam simGetObjectStringParam;
extern ptrSimSetObjectStringParam simSetObjectStringParam;
extern ptrSimSetSimulationPassesPerRenderingPass simSetSimulationPassesPerRenderingPass;
extern ptrSimGetRotationAxis simGetRotationAxis;
extern ptrSimRotateAroundAxis simRotateAroundAxis;
extern ptrSimGetJointForce simGetJointForce;
extern ptrSimGetJointTargetForce simGetJointTargetForce;
extern ptrSimSetJointTargetForce simSetJointTargetForce;
extern ptrSimCameraFitToView simCameraFitToView;
extern ptrSimPersistentDataWrite simPersistentDataWrite;
extern ptrSimPersistentDataRead simPersistentDataRead;
extern ptrSimIsHandle simIsHandle;
extern ptrSimHandleVisionSensor simHandleVisionSensor;
extern ptrSimReadVisionSensor simReadVisionSensor;
extern ptrSimResetVisionSensor simResetVisionSensor;
extern ptrSimCheckVisionSensor simCheckVisionSensor;
extern ptrSimCheckVisionSensorEx simCheckVisionSensorEx;
extern ptrSimGetVisionSensorImg simGetVisionSensorImg;
extern ptrSimSetVisionSensorImg simSetVisionSensorImg;
extern ptrSimGetVisionSensorRes simGetVisionSensorRes;
extern ptrSimGetVisionSensorDepth simGetVisionSensorDepth;
extern ptr_simSetVisionSensorDepth _simSetVisionSensorDepth;
extern ptrSimGetObjectQuaternion simGetObjectQuaternion;
extern ptrSimSetObjectQuaternion simSetObjectQuaternion;
extern ptrSimRuckigPos simRuckigPos;
extern ptrSimRuckigVel simRuckigVel;
extern ptrSimRuckigStep simRuckigStep;
extern ptrSimRuckigRemove simRuckigRemove;
extern ptrSimGroupShapes simGroupShapes;
extern ptrSimUngroupShape simUngroupShape;
extern ptrSimConvexDecompose simConvexDecompose;
extern ptrSimQuitSimulator simQuitSimulator;
extern ptrSimSetShapeMaterial simSetShapeMaterial;
extern ptrSimGetTextureId simGetTextureId;
extern ptrSimReadTexture simReadTexture;
extern ptrSimWriteTexture simWriteTexture;
extern ptrSimCreateTexture simCreateTexture;
extern ptrSimWriteCustomDataBlock simWriteCustomDataBlock;
extern ptrSimReadCustomDataBlock simReadCustomDataBlock;
extern ptrSimReadCustomDataBlockTags simReadCustomDataBlockTags;
extern ptrSimGetShapeGeomInfo simGetShapeGeomInfo;
extern ptrSimGetObjects simGetObjects;
extern ptrSimGetObjectsInTree simGetObjectsInTree;
extern ptrSimScaleObject simScaleObject;
extern ptrSimSetShapeTexture simSetShapeTexture;
extern ptrSimGetShapeTextureId simGetShapeTextureId;
extern ptrSimCreateCollectionEx simCreateCollectionEx;
extern ptrSimAddItemToCollection simAddItemToCollection;
extern ptrSimDestroyCollection simDestroyCollection;
extern ptrSimGetCollectionObjects simGetCollectionObjects;
extern ptrSimGetScriptInt32Param simGetScriptInt32Param;
extern ptrSimSetScriptInt32Param simSetScriptInt32Param;
extern ptrSimGetScriptStringParam simGetScriptStringParam;
extern ptrSimSetScriptStringParam simSetScriptStringParam;
extern ptrSimAlignShapeBB simAlignShapeBB;
extern ptrSimRelocateShapeFrame simRelocateShapeFrame;
extern ptrSimSaveImage simSaveImage;
extern ptrSimLoadImage simLoadImage;
extern ptrSimGetScaledImage simGetScaledImage;
extern ptrSimTransformImage simTransformImage;
extern ptrSimGetQHull simGetQHull;
extern ptrSimGetDecimatedMesh simGetDecimatedMesh;
extern ptrSimCallScriptFunctionEx simCallScriptFunctionEx;
extern ptrSimGetExtensionString simGetExtensionString;
extern ptrSimComputeMassAndInertia simComputeMassAndInertia;
extern ptrSimCreateStack simCreateStack;
extern ptrSimReleaseStack simReleaseStack;
extern ptrSimCopyStack simCopyStack;
extern ptrSimPushNullOntoStack simPushNullOntoStack;
extern ptrSimPushBoolOntoStack simPushBoolOntoStack;
extern ptrSimPushInt32OntoStack simPushInt32OntoStack;
extern ptrSimPushInt64OntoStack simPushInt64OntoStack;
extern ptrSimPushFloatOntoStack simPushFloatOntoStack;
extern ptrSimPushDoubleOntoStack simPushDoubleOntoStack;
extern ptrSimPushStringOntoStack simPushStringOntoStack;
extern ptrSimPushUInt8TableOntoStack simPushUInt8TableOntoStack;
extern ptrSimPushInt32TableOntoStack simPushInt32TableOntoStack;
extern ptrSimPushInt64TableOntoStack simPushInt64TableOntoStack;
extern ptrSimPushFloatTableOntoStack simPushFloatTableOntoStack;
extern ptrSimPushDoubleTableOntoStack simPushDoubleTableOntoStack;
extern ptrSimPushTableOntoStack simPushTableOntoStack;
extern ptrSimInsertDataIntoStackTable simInsertDataIntoStackTable;
extern ptrSimGetStackSize simGetStackSize;
extern ptrSimPopStackItem simPopStackItem;
extern ptrSimMoveStackItemToTop simMoveStackItemToTop;
extern ptrSimIsStackValueNull simIsStackValueNull;
extern ptrSimGetStackBoolValue simGetStackBoolValue;
extern ptrSimGetStackInt32Value simGetStackInt32Value;
extern ptrSimGetStackInt64Value simGetStackInt64Value;
extern ptrSimGetStackFloatValue simGetStackFloatValue;
extern ptrSimGetStackDoubleValue simGetStackDoubleValue;
extern ptrSimGetStackStringValue simGetStackStringValue;
extern ptrSimGetStackTableInfo simGetStackTableInfo;
extern ptrSimGetStackUInt8Table simGetStackUInt8Table;
extern ptrSimGetStackInt32Table simGetStackInt32Table;
extern ptrSimGetStackInt64Table simGetStackInt64Table;
extern ptrSimGetStackFloatTable simGetStackFloatTable;
extern ptrSimGetStackDoubleTable simGetStackDoubleTable;
extern ptrSimUnfoldStackTable simUnfoldStackTable;
extern ptrSimDebugStack simDebugStack;
extern ptrSimGetEngineFloatParam simGetEngineFloatParam;
extern ptrSimGetEngineInt32Param simGetEngineInt32Param;
extern ptrSimGetEngineBoolParam simGetEngineBoolParam;
extern ptrSimSetEngineFloatParam simSetEngineFloatParam;
extern ptrSimSetEngineInt32Param simSetEngineInt32Param;
extern ptrSimSetEngineBoolParam simSetEngineBoolParam;
extern ptrSimCreateOctree simCreateOctree;
extern ptrSimCreatePointCloud simCreatePointCloud;
extern ptrSimSetPointCloudOptions simSetPointCloudOptions;
extern ptrSimGetPointCloudOptions simGetPointCloudOptions;
extern ptrSimInsertVoxelsIntoOctree simInsertVoxelsIntoOctree;
extern ptrSimRemoveVoxelsFromOctree simRemoveVoxelsFromOctree;
extern ptrSimInsertPointsIntoPointCloud simInsertPointsIntoPointCloud;
extern ptrSimRemovePointsFromPointCloud simRemovePointsFromPointCloud;
extern ptrSimIntersectPointsWithPointCloud simIntersectPointsWithPointCloud;
extern ptrSimGetOctreeVoxels simGetOctreeVoxels;
extern ptrSimGetPointCloudPoints simGetPointCloudPoints;
extern ptrSimInsertObjectIntoOctree simInsertObjectIntoOctree;
extern ptrSimSubtractObjectFromOctree simSubtractObjectFromOctree;
extern ptrSimInsertObjectIntoPointCloud simInsertObjectIntoPointCloud;
extern ptrSimSubtractObjectFromPointCloud simSubtractObjectFromPointCloud;
extern ptrSimCheckOctreePointOccupancy simCheckOctreePointOccupancy;
extern ptrSimOpenTextEditor simOpenTextEditor;
extern ptrSimPackTable simPackTable;
extern ptrSimUnpackTable simUnpackTable;
extern ptrSimSetReferencedHandles simSetReferencedHandles;
extern ptrSimGetReferencedHandles simGetReferencedHandles;
extern ptrSimGetShapeViz simGetShapeViz;
extern ptrSimExecuteScriptString simExecuteScriptString;
extern ptrSimGetApiFunc simGetApiFunc;
extern ptrSimGetApiInfo simGetApiInfo;
extern ptrSimSetModuleInfo simSetModuleInfo;
extern ptrSimGetModuleInfo simGetModuleInfo;
extern ptrSimIsDeprecated simIsDeprecated;
extern ptrSimGetPersistentDataTags simGetPersistentDataTags;
extern ptrSimEventNotification simEventNotification;
extern ptrSimApplyTexture simApplyTexture;
extern ptrSimSetJointDependency simSetJointDependency;
extern ptrSimGetJointDependency simGetJointDependency;
extern ptrSimGetShapeMass simGetShapeMass;
extern ptrSimSetShapeMass simSetShapeMass;
extern ptrSimGetShapeInertia simGetShapeInertia;
extern ptrSimSetShapeInertia simSetShapeInertia;
extern ptrSimIsDynamicallyEnabled simIsDynamicallyEnabled;
extern ptrSimGenerateShapeFromPath simGenerateShapeFromPath;
extern ptrSimGetClosestPosOnPath simGetClosestPosOnPath;
extern ptrSimInitScript simInitScript;
extern ptrSimModuleEntry simModuleEntry;
extern ptrSimCheckExecAuthorization simCheckExecAuthorization;


/* Following courtesy of Stephen James: */
extern ptrSimExtLaunchUIThread simExtLaunchUIThread;
extern ptrSimExtCanInitSimThread simExtCanInitSimThread;
extern ptrSimExtSimThreadInit simExtSimThreadInit;
extern ptrSimExtSimThreadDestroy simExtSimThreadDestroy;
extern ptrSimExtPostExitRequest simExtPostExitRequest;
extern ptrSimExtGetExitRequest simExtGetExitRequest;
extern ptrSimExtStep simExtStep;
extern ptrSimExtCallScriptFunction simExtCallScriptFunction;

extern ptr_simSetDynamicSimulationIconCode _simSetDynamicSimulationIconCode;
extern ptr_simSetDynamicObjectFlagForVisualization _simSetDynamicObjectFlagForVisualization;
extern ptr_simGetObjectListSize _simGetObjectListSize;
extern ptr_simGetObjectFromIndex _simGetObjectFromIndex;
extern ptr_simGetObjectID _simGetObjectID;
extern ptr_simGetObjectType _simGetObjectType;
extern ptr_simGetObjectChildren _simGetObjectChildren;
extern ptr_simGetParentObject _simGetParentObject;
extern ptr_simGetObject _simGetObject;
extern ptr_simGetIkGroupObject _simGetIkGroupObject;
extern ptr_simMpHandleIkGroupObject _simMpHandleIkGroupObject;
extern ptr_simGetObjectLocalTransformation _simGetObjectLocalTransformation;
extern ptr_simSetObjectLocalTransformation _simSetObjectLocalTransformation;
extern ptr_simDynReportObjectCumulativeTransformation _simDynReportObjectCumulativeTransformation;
extern ptr_simSetObjectCumulativeTransformation _simSetObjectCumulativeTransformation;
extern ptr_simGetObjectCumulativeTransformation _simGetObjectCumulativeTransformation;
extern ptr_simIsShapeDynamicallyStatic _simIsShapeDynamicallyStatic;
extern ptr_simGetTreeDynamicProperty _simGetTreeDynamicProperty;
extern ptr_simGetDummyLinkType _simGetDummyLinkType;
extern ptr_simGetJointMode _simGetJointMode;
extern ptr_simIsJointInHybridOperation _simIsJointInHybridOperation;
extern ptr_simDisableDynamicTreeForManipulation _simDisableDynamicTreeForManipulation;
extern ptr_simIsShapeDynamicallyRespondable _simIsShapeDynamicallyRespondable;
extern ptr_simGetDynamicCollisionMask _simGetDynamicCollisionMask;
extern ptr_simGetLastParentForLocalGlobalCollidable _simGetLastParentForLocalGlobalCollidable;
extern ptr_simSetJointVelocity _simSetJointVelocity;
extern ptr_simSetJointPosition _simSetJointPosition;
extern ptr_simGetJointPosition _simGetJointPosition;
extern ptr_simSetDynamicMotorPositionControlTargetPosition _simSetDynamicMotorPositionControlTargetPosition;
extern ptr_simGetInitialDynamicVelocity _simGetInitialDynamicVelocity;
extern ptr_simSetInitialDynamicVelocity _simSetInitialDynamicVelocity;
extern ptr_simGetInitialDynamicAngVelocity _simGetInitialDynamicAngVelocity;
extern ptr_simSetInitialDynamicAngVelocity _simSetInitialDynamicAngVelocity;
extern ptr_simGetStartSleeping _simGetStartSleeping;
extern ptr_simGetWasPutToSleepOnce _simGetWasPutToSleepOnce;
extern ptr_simGetDynamicsFullRefreshFlag _simGetDynamicsFullRefreshFlag;
extern ptr_simSetDynamicsFullRefreshFlag _simSetDynamicsFullRefreshFlag;
extern ptr_simSetShapeDynamicVelocity _simSetShapeDynamicVelocity;
extern ptr_simGetAdditionalForceAndTorque _simGetAdditionalForceAndTorque;
extern ptr_simClearAdditionalForceAndTorque _simClearAdditionalForceAndTorque;
extern ptr_simGetJointPositionInterval _simGetJointPositionInterval;
extern ptr_simGetJointType _simGetJointType;
extern ptr_simGetDynamicMotorTargetPosition _simGetDynamicMotorTargetPosition;
extern ptr_simGetDynamicMotorTargetVelocity _simGetDynamicMotorTargetVelocity;
extern ptr_simGetDynamicMotorMaxForce _simGetDynamicMotorMaxForce;
extern ptr_simGetDynamicMotorUpperLimitVelocity _simGetDynamicMotorUpperLimitVelocity;
extern ptr_simSetDynamicMotorReflectedPositionFromDynamicEngine _simSetDynamicMotorReflectedPositionFromDynamicEngine;
extern ptr_simSetJointSphericalTransformation _simSetJointSphericalTransformation;
extern ptr_simAddForceSensorCumulativeForcesAndTorques _simAddForceSensorCumulativeForcesAndTorques;
extern ptr_simAddJointCumulativeForcesOrTorques _simAddJointCumulativeForcesOrTorques;
extern ptr_simGetGeomWrapFromGeomProxy _simGetGeomWrapFromGeomProxy;
extern ptr_simGetPurePrimitiveType _simGetPurePrimitiveType;
extern ptr_simIsGeomWrapGeometric _simIsGeomWrapGeometric;
extern ptr_simIsGeomWrapConvex _simIsGeomWrapConvex;
extern ptr_simGetGeometricCount _simGetGeometricCount;
extern ptr_simGetAllGeometrics _simGetAllGeometrics;
extern ptr_simGetPurePrimitiveSizes _simGetPurePrimitiveSizes;
extern ptr_simMakeDynamicAnnouncement _simMakeDynamicAnnouncement;
extern ptr_simGetVerticesLocalFrame _simGetVerticesLocalFrame;
extern ptr_simGetHeightfieldData _simGetHeightfieldData;
extern ptr_simGetCumulativeMeshes _simGetCumulativeMeshes;
extern ptr_simGetMass _simGetMass;
extern ptr_simGetLocalInertiaInfo _simGetLocalInertiaInfo;
extern ptr_simGetGravity _simGetGravity;
extern ptr_simGetTimeDiffInMs _simGetTimeDiffInMs;
extern ptr_simDoEntitiesCollide _simDoEntitiesCollide;
extern ptr_simGetDistanceBetweenEntitiesIfSmaller _simGetDistanceBetweenEntitiesIfSmaller;
extern ptr_simHandleJointControl _simHandleJointControl;
extern ptr_simHandleCustomContact _simHandleCustomContact;
extern ptr_simGetPureHollowScaling _simGetPureHollowScaling;
extern ptr_simGetJointDynCtrlMode _simGetJointDynCtrlMode;
extern ptr_simDynCallback _simDynCallback;

#include "simLib-old.h"
#endif
